import Queue, { QueueOptions } from './Queue';
export declare type PriorityQueueCompareFunction<T> = (a: T, b: T) => -1 | 1 | 0;
export interface PriorityQueueOptions<T> extends QueueOptions<T> {
    compare?: PriorityQueueCompareFunction<T> | (string | number)[] | string;
}
export declare class PriorityQueue<T> extends Queue<T> {
    constructor(options?: PriorityQueueOptions<T>);
    compare(a: T, b: T): 0 | 1 | -1;
    push(...items: T[]): number;
}
export default PriorityQueue;
