"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const get = require("lodash.get");
const Queue_1 = require("./Queue");
class PriorityQueue extends Queue_1.default {
    constructor(options = {}) {
        super(options);
        if (options.compare) {
            if (typeof options.compare === 'function') {
                this.compare = options.compare;
            }
            else {
                const compareKey = options.compare;
                this.compare = (a, b) => {
                    a = get(a, compareKey);
                    b = get(b, compareKey);
                    return a < b ? -1 : a > b ? 1 : 0;
                };
            }
        }
    }
    compare(a, b) {
        return a < b ? -1 : a > b ? 1 : 0;
    }
    push(...items) {
        const result = super.push(...items);
        this.sort(this.compare);
        return result;
    }
}
exports.PriorityQueue = PriorityQueue;
exports.default = PriorityQueue;
//# sourceMappingURL=PriorityQueue.js.map